//-- Skeleton for Top level of Verilog Pcore needing an OPB slave Interface
//-- Also see OPB_Skeleton_VHDL.vhd for an alternative set of
//-- inputs/outputs.
//
//-- For more information on integrating your own Verilog pcore into a 
//-- MicroBlaze project please see "Integrating a Verilog design into a
//-- MicroBlaze System" by Lorne Applebaum
//
//-- University of Toronto - ECE532
//-- July 2004
//----------------------------------------------------------------------------

module mypcore_opbinterface(
	OPB_clk, 
	OPB_hwXfer, 
	OPB_fwXfer, 
	OPB_ABus, 
	OPB_DBus,
	OPB_RNW, 
	OPB_select, 
	OPB_seqAddr, 

	Sln_DBus,
	Sln_DBusEn, 
	Sln_hwAck, 
	Sln_fwAck, 
	Sln_errAck, 
	Sln_retry, 
	Sln_toutSup, 
	Sln_xferAck
	       );
   
   parameter OPB_WIDTH = 32;
   parameter C_BASEADDR = 32'hffffff00;
   parameter C_HIGHADDR = 32'hffffffff;

   //Put any additional parameters you want to use here

   
   input     OPB_clk;
   input     OPB_hwXfer;
   input     OPB_fwXfer;
   input [OPB_WIDTH - 1:0] OPB_ABus;
   input [OPB_WIDTH - 1:0] OPB_DBus;
   input     OPB_RNW;
   input     OPB_select;
   input     OPB_seqAddr;

   output [OPB_WIDTH - 1:0] Sln_DBus;
   output 		   Sln_DBusEn;
   output 		   Sln_hwAck;
   output 		   Sln_fwAck;
   output 		   Sln_errAck;
   output 		   Sln_retry;
   output 		   Sln_toutSup;
   output 		   Sln_xferAck;

// Put any additional inputs/outputs you want to have here

// Put any logic for this level of the module here
   
// Instantiate components as needed here
   
endmodule









