-- Skeleton for Top level of VHDL Pcore needing an OPB slave Interface
-- Also see OPB_Skeleton_Verilog.v for an alternative set of
-- inputs/outputs

-- For more information on integrating your own Verilog pcore into a 
-- MicroBlaze project please see "Integrating a Verilog design into a
-- MicroBlaze System" by Lorne Applebaum.  The principles in that
-- document can also be applied to a VHDL pcore.

-- VHDL pcores can also benefit from the EDK Create/Import Peripheral
-- Wizard that is documented in Chapter 4 of the EST Guide for EDK 6.2i

-- As an example see snoopy.vhd by Lesley Shannon

-- University of Toronto - ECE532
-- July 2004
----------------------------------------------------------------------------

library IEEE;
use IEEE.STD_Logic_1164.all; 
use IEEE.STD_Logic_arith.all;
use IEEE.STD_Logic_unsigned.all;

use Work.mypcore_types.all;

entity mypcore_opbinterface is
  generic(C_OPB_AWIDTH:		INTEGER := 32;
	  C_OPB_DWIDTH:		INTEGER := 32;
	  C_BASEADDR:		STD_LOGIC_VECTOR(0 to 31) := X"FFFF_FFE0";
	  C_HIGHADDR:		STD_LOGIC_VECTOR(0 to 31) := X"FFFF_FFFF";
	  RESET_ADDR:		STD_LOGIC_VECTOR(0 to 31) := X"FFFF_FFE4";
          -- Put any additional generics you want to use here
	  MY_GENERIC1:		INTEGER := 2; --Max of 10, Min of 1
	  MY_GENERIC2:		STD_LOGIC_VECTOR(0 to 31) := X"0080_0140";
	  MY_GENERIC3:		STD_LOGIC_VECTOR(0 to 31) := X"0080_0154"
	  );
  port(	OPB_Clk:		in	STD_LOGIC;
	OPB_Rst:		in	STD_LOGIC;

	OPB_ABus:		in	STD_LOGIC_VECTOR(0 to C_OPB_AWIDTH-1);
	OPB_BE:			in	STD_LOGIC_VECTOR(0 to C_OPB_DWIDTH/8 -1);
	OPB_DBus:		in	STD_LOGIC_VECTOR(0 to C_OPB_DWIDTH-1);
	OPB_RNW:		in	STD_LOGIC;
	OPB_select:		in	STD_LOGIC;
	OPB_seqAddr:		in	STD_LOGIC;

	mypcore_DBus:		out	STD_LOGIC_VECTOR(0 to C_OPB_DWIDTH-1);
	mypcore_errAck:		out	STD_LOGIC;
	mypcore_retry:		out	STD_LOGIC;
	mypcore_toutSup:	out	STD_LOGIC;
	mypcore_xferAck:	out	STD_LOGIC;

        -- Put any additional inputs/outputs you want to have here
	myinput1:		in	STD_LOGIC_VECTOR(0 to 31);
	myinput2:		in	STD_LOGIC);

end entity mypcore_opbinterface;

architecture behaviour of mypcore_opbinterface is
-- Declare components and signals here with GENERIC's set as needed
begin

-- Instantiate your components and put any additional logic for driving
-- the pcore's outputs to the OPB here.

end architecture behaviour;

